#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct AvatarUploadAttributes {
    #[prost(string, tag = "1")]
    pub key: ::prost::alloc::string::String,
    #[prost(string, tag = "2")]
    pub credential: ::prost::alloc::string::String,
    #[prost(string, tag = "3")]
    pub acl: ::prost::alloc::string::String,
    #[prost(string, tag = "4")]
    pub algorithm: ::prost::alloc::string::String,
    #[prost(string, tag = "5")]
    pub date: ::prost::alloc::string::String,
    #[prost(string, tag = "6")]
    pub policy: ::prost::alloc::string::String,
    #[prost(string, tag = "7")]
    pub signature: ::prost::alloc::string::String,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct Member {
    #[prost(bytes = "vec", tag = "1")]
    pub user_id: ::prost::alloc::vec::Vec<u8>,
    #[prost(enumeration = "member::Role", tag = "2")]
    pub role: i32,
    #[prost(bytes = "vec", tag = "3")]
    pub profile_key: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "4")]
    pub presentation: ::prost::alloc::vec::Vec<u8>,
    #[prost(uint32, tag = "5")]
    pub joined_at_revision: u32,
}
/// Nested message and enum types in `Member`.
pub mod member {
    #[derive(
        Clone,
        Copy,
        Debug,
        PartialEq,
        Eq,
        Hash,
        PartialOrd,
        Ord,
        ::prost::Enumeration
    )]
    #[repr(i32)]
    pub enum Role {
        Unknown = 0,
        Default = 1,
        Administrator = 2,
    }
    impl Role {
        /// String value of the enum field names used in the ProtoBuf definition.
        ///
        /// The values are not transformed in any way and thus are considered stable
        /// (if the ProtoBuf definition does not change) and safe for programmatic use.
        pub fn as_str_name(&self) -> &'static str {
            match self {
                Role::Unknown => "UNKNOWN",
                Role::Default => "DEFAULT",
                Role::Administrator => "ADMINISTRATOR",
            }
        }
        /// Creates an enum from field names used in the ProtoBuf definition.
        pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
            match value {
                "UNKNOWN" => Some(Self::Unknown),
                "DEFAULT" => Some(Self::Default),
                "ADMINISTRATOR" => Some(Self::Administrator),
                _ => None,
            }
        }
    }
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct PendingMember {
    #[prost(message, optional, tag = "1")]
    pub member: ::core::option::Option<Member>,
    #[prost(bytes = "vec", tag = "2")]
    pub added_by_user_id: ::prost::alloc::vec::Vec<u8>,
    #[prost(uint64, tag = "3")]
    pub timestamp: u64,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct RequestingMember {
    #[prost(bytes = "vec", tag = "1")]
    pub user_id: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "2")]
    pub profile_key: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "3")]
    pub presentation: ::prost::alloc::vec::Vec<u8>,
    #[prost(uint64, tag = "4")]
    pub timestamp: u64,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct BannedMember {
    #[prost(bytes = "vec", tag = "1")]
    pub user_id: ::prost::alloc::vec::Vec<u8>,
    #[prost(uint64, tag = "2")]
    pub timestamp: u64,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct AccessControl {
    #[prost(enumeration = "access_control::AccessRequired", tag = "1")]
    pub attributes: i32,
    #[prost(enumeration = "access_control::AccessRequired", tag = "2")]
    pub members: i32,
    #[prost(enumeration = "access_control::AccessRequired", tag = "3")]
    pub add_from_invite_link: i32,
}
/// Nested message and enum types in `AccessControl`.
pub mod access_control {
    #[derive(
        Clone,
        Copy,
        Debug,
        PartialEq,
        Eq,
        Hash,
        PartialOrd,
        Ord,
        ::prost::Enumeration
    )]
    #[repr(i32)]
    pub enum AccessRequired {
        Unknown = 0,
        Any = 1,
        Member = 2,
        Administrator = 3,
        Unsatisfiable = 4,
    }
    impl AccessRequired {
        /// String value of the enum field names used in the ProtoBuf definition.
        ///
        /// The values are not transformed in any way and thus are considered stable
        /// (if the ProtoBuf definition does not change) and safe for programmatic use.
        pub fn as_str_name(&self) -> &'static str {
            match self {
                AccessRequired::Unknown => "UNKNOWN",
                AccessRequired::Any => "ANY",
                AccessRequired::Member => "MEMBER",
                AccessRequired::Administrator => "ADMINISTRATOR",
                AccessRequired::Unsatisfiable => "UNSATISFIABLE",
            }
        }
        /// Creates an enum from field names used in the ProtoBuf definition.
        pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
            match value {
                "UNKNOWN" => Some(Self::Unknown),
                "ANY" => Some(Self::Any),
                "MEMBER" => Some(Self::Member),
                "ADMINISTRATOR" => Some(Self::Administrator),
                "UNSATISFIABLE" => Some(Self::Unsatisfiable),
                _ => None,
            }
        }
    }
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct Group {
    #[prost(bytes = "vec", tag = "1")]
    pub public_key: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "2")]
    pub title: ::prost::alloc::vec::Vec<u8>,
    #[prost(string, tag = "3")]
    pub avatar: ::prost::alloc::string::String,
    #[prost(bytes = "vec", tag = "4")]
    pub disappearing_messages_timer: ::prost::alloc::vec::Vec<u8>,
    #[prost(message, optional, tag = "5")]
    pub access_control: ::core::option::Option<AccessControl>,
    #[prost(uint32, tag = "6")]
    pub revision: u32,
    #[prost(message, repeated, tag = "7")]
    pub members: ::prost::alloc::vec::Vec<Member>,
    #[prost(message, repeated, tag = "8")]
    pub pending_members: ::prost::alloc::vec::Vec<PendingMember>,
    #[prost(message, repeated, tag = "9")]
    pub requesting_members: ::prost::alloc::vec::Vec<RequestingMember>,
    #[prost(bytes = "vec", tag = "10")]
    pub invite_link_password: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "11")]
    pub description: ::prost::alloc::vec::Vec<u8>,
    #[prost(bool, tag = "12")]
    pub announcements_only: bool,
    #[prost(message, repeated, tag = "13")]
    pub banned_members: ::prost::alloc::vec::Vec<BannedMember>,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GroupChange {
    #[prost(bytes = "vec", tag = "1")]
    pub actions: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "2")]
    pub server_signature: ::prost::alloc::vec::Vec<u8>,
    #[prost(uint32, tag = "3")]
    pub change_epoch: u32,
}
/// Nested message and enum types in `GroupChange`.
pub mod group_change {
    #[allow(clippy::derive_partial_eq_without_eq)]
    #[derive(Clone, PartialEq, ::prost::Message)]
    pub struct Actions {
        #[prost(bytes = "vec", tag = "1")]
        pub source_service_id: ::prost::alloc::vec::Vec<u8>,
        #[prost(uint32, tag = "2")]
        pub revision: u32,
        #[prost(message, repeated, tag = "3")]
        pub add_members: ::prost::alloc::vec::Vec<actions::AddMemberAction>,
        #[prost(message, repeated, tag = "4")]
        pub delete_members: ::prost::alloc::vec::Vec<actions::DeleteMemberAction>,
        #[prost(message, repeated, tag = "5")]
        pub modify_member_roles: ::prost::alloc::vec::Vec<
            actions::ModifyMemberRoleAction,
        >,
        #[prost(message, repeated, tag = "6")]
        pub modify_member_profile_keys: ::prost::alloc::vec::Vec<
            actions::ModifyMemberProfileKeyAction,
        >,
        #[prost(message, repeated, tag = "7")]
        pub add_pending_members: ::prost::alloc::vec::Vec<
            actions::AddPendingMemberAction,
        >,
        #[prost(message, repeated, tag = "8")]
        pub delete_pending_members: ::prost::alloc::vec::Vec<
            actions::DeletePendingMemberAction,
        >,
        #[prost(message, repeated, tag = "9")]
        pub promote_pending_members: ::prost::alloc::vec::Vec<
            actions::PromotePendingMemberAction,
        >,
        #[prost(message, optional, tag = "10")]
        pub modify_title: ::core::option::Option<actions::ModifyTitleAction>,
        #[prost(message, optional, tag = "11")]
        pub modify_avatar: ::core::option::Option<actions::ModifyAvatarAction>,
        #[prost(message, optional, tag = "12")]
        pub modify_disappearing_messages_timer: ::core::option::Option<
            actions::ModifyDisappearingMessagesTimerAction,
        >,
        #[prost(message, optional, tag = "13")]
        pub modify_attributes_access: ::core::option::Option<
            actions::ModifyAttributesAccessControlAction,
        >,
        #[prost(message, optional, tag = "14")]
        pub modify_member_access: ::core::option::Option<
            actions::ModifyMembersAccessControlAction,
        >,
        #[prost(message, optional, tag = "15")]
        pub modify_add_from_invite_link_access: ::core::option::Option<
            actions::ModifyAddFromInviteLinkAccessControlAction,
        >,
        #[prost(message, repeated, tag = "16")]
        pub add_requesting_members: ::prost::alloc::vec::Vec<
            actions::AddRequestingMemberAction,
        >,
        #[prost(message, repeated, tag = "17")]
        pub delete_requesting_members: ::prost::alloc::vec::Vec<
            actions::DeleteRequestingMemberAction,
        >,
        #[prost(message, repeated, tag = "18")]
        pub promote_requesting_members: ::prost::alloc::vec::Vec<
            actions::PromoteRequestingMemberAction,
        >,
        #[prost(message, optional, tag = "19")]
        pub modify_invite_link_password: ::core::option::Option<
            actions::ModifyInviteLinkPasswordAction,
        >,
        #[prost(message, optional, tag = "20")]
        pub modify_description: ::core::option::Option<actions::ModifyDescriptionAction>,
        #[prost(message, optional, tag = "21")]
        pub modify_announcements_only: ::core::option::Option<
            actions::ModifyAnnouncementsOnlyAction,
        >,
        #[prost(message, repeated, tag = "22")]
        pub add_banned_members: ::prost::alloc::vec::Vec<actions::AddBannedMemberAction>,
        #[prost(message, repeated, tag = "23")]
        pub delete_banned_members: ::prost::alloc::vec::Vec<
            actions::DeleteBannedMemberAction,
        >,
        #[prost(message, repeated, tag = "24")]
        pub promote_pending_pni_aci_members: ::prost::alloc::vec::Vec<
            actions::PromotePendingPniAciMemberProfileKeyAction,
        >,
    }
    /// Nested message and enum types in `Actions`.
    pub mod actions {
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct AddMemberAction {
            #[prost(message, optional, tag = "1")]
            pub added: ::core::option::Option<super::super::Member>,
            #[prost(bool, tag = "2")]
            pub join_from_invite_link: bool,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct DeleteMemberAction {
            #[prost(bytes = "vec", tag = "1")]
            pub deleted_user_id: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyMemberRoleAction {
            #[prost(bytes = "vec", tag = "1")]
            pub user_id: ::prost::alloc::vec::Vec<u8>,
            #[prost(enumeration = "super::super::member::Role", tag = "2")]
            pub role: i32,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyMemberProfileKeyAction {
            /// Only set when sending to server
            #[prost(bytes = "vec", tag = "1")]
            pub presentation: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "2")]
            pub user_id: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "3")]
            pub profile_key: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct AddPendingMemberAction {
            #[prost(message, optional, tag = "1")]
            pub added: ::core::option::Option<super::super::PendingMember>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct DeletePendingMemberAction {
            #[prost(bytes = "vec", tag = "1")]
            pub deleted_user_id: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct PromotePendingMemberAction {
            /// Only set when sending to server
            #[prost(bytes = "vec", tag = "1")]
            pub presentation: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "2")]
            pub user_id: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "3")]
            pub profile_key: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct PromotePendingPniAciMemberProfileKeyAction {
            /// Only set when sending to server
            #[prost(bytes = "vec", tag = "1")]
            pub presentation: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "2")]
            pub user_id: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "3")]
            pub pni: ::prost::alloc::vec::Vec<u8>,
            /// Only set when receiving from server
            #[prost(bytes = "vec", tag = "4")]
            pub profile_key: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct AddRequestingMemberAction {
            #[prost(message, optional, tag = "1")]
            pub added: ::core::option::Option<super::super::RequestingMember>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct DeleteRequestingMemberAction {
            #[prost(bytes = "vec", tag = "1")]
            pub deleted_user_id: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct PromoteRequestingMemberAction {
            #[prost(bytes = "vec", tag = "1")]
            pub user_id: ::prost::alloc::vec::Vec<u8>,
            #[prost(enumeration = "super::super::member::Role", tag = "2")]
            pub role: i32,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct AddBannedMemberAction {
            #[prost(message, optional, tag = "1")]
            pub added: ::core::option::Option<super::super::BannedMember>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct DeleteBannedMemberAction {
            #[prost(bytes = "vec", tag = "1")]
            pub deleted_user_id: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyTitleAction {
            #[prost(bytes = "vec", tag = "1")]
            pub title: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyDescriptionAction {
            #[prost(bytes = "vec", tag = "1")]
            pub description: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyAvatarAction {
            #[prost(string, tag = "1")]
            pub avatar: ::prost::alloc::string::String,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyDisappearingMessagesTimerAction {
            #[prost(bytes = "vec", tag = "1")]
            pub timer: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyAttributesAccessControlAction {
            #[prost(
                enumeration = "super::super::access_control::AccessRequired",
                tag = "1"
            )]
            pub attributes_access: i32,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyMembersAccessControlAction {
            #[prost(
                enumeration = "super::super::access_control::AccessRequired",
                tag = "1"
            )]
            pub members_access: i32,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyAddFromInviteLinkAccessControlAction {
            #[prost(
                enumeration = "super::super::access_control::AccessRequired",
                tag = "1"
            )]
            pub add_from_invite_link_access: i32,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyInviteLinkPasswordAction {
            #[prost(bytes = "vec", tag = "1")]
            pub invite_link_password: ::prost::alloc::vec::Vec<u8>,
        }
        #[allow(clippy::derive_partial_eq_without_eq)]
        #[derive(Clone, PartialEq, ::prost::Message)]
        pub struct ModifyAnnouncementsOnlyAction {
            #[prost(bool, tag = "1")]
            pub announcements_only: bool,
        }
    }
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GroupChanges {
    #[prost(message, repeated, tag = "1")]
    pub group_changes: ::prost::alloc::vec::Vec<group_changes::GroupChangeState>,
}
/// Nested message and enum types in `GroupChanges`.
pub mod group_changes {
    #[allow(clippy::derive_partial_eq_without_eq)]
    #[derive(Clone, PartialEq, ::prost::Message)]
    pub struct GroupChangeState {
        #[prost(message, optional, tag = "1")]
        pub group_change: ::core::option::Option<super::GroupChange>,
        #[prost(message, optional, tag = "2")]
        pub group_state: ::core::option::Option<super::Group>,
    }
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GroupAttributeBlob {
    #[prost(oneof = "group_attribute_blob::Content", tags = "1, 2, 3, 4")]
    pub content: ::core::option::Option<group_attribute_blob::Content>,
}
/// Nested message and enum types in `GroupAttributeBlob`.
pub mod group_attribute_blob {
    #[allow(clippy::derive_partial_eq_without_eq)]
    #[derive(Clone, PartialEq, ::prost::Oneof)]
    pub enum Content {
        #[prost(string, tag = "1")]
        Title(::prost::alloc::string::String),
        #[prost(bytes, tag = "2")]
        Avatar(::prost::alloc::vec::Vec<u8>),
        #[prost(uint32, tag = "3")]
        DisappearingMessagesDuration(u32),
        #[prost(string, tag = "4")]
        Description(::prost::alloc::string::String),
    }
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GroupInviteLink {
    #[prost(oneof = "group_invite_link::Contents", tags = "1")]
    pub contents: ::core::option::Option<group_invite_link::Contents>,
}
/// Nested message and enum types in `GroupInviteLink`.
pub mod group_invite_link {
    #[allow(clippy::derive_partial_eq_without_eq)]
    #[derive(Clone, PartialEq, ::prost::Message)]
    pub struct GroupInviteLinkContentsV1 {
        #[prost(bytes = "vec", tag = "1")]
        pub group_master_key: ::prost::alloc::vec::Vec<u8>,
        #[prost(bytes = "vec", tag = "2")]
        pub invite_link_password: ::prost::alloc::vec::Vec<u8>,
    }
    #[allow(clippy::derive_partial_eq_without_eq)]
    #[derive(Clone, PartialEq, ::prost::Oneof)]
    pub enum Contents {
        #[prost(message, tag = "1")]
        V1Contents(GroupInviteLinkContentsV1),
    }
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GroupJoinInfo {
    #[prost(bytes = "vec", tag = "1")]
    pub public_key: ::prost::alloc::vec::Vec<u8>,
    #[prost(bytes = "vec", tag = "2")]
    pub title: ::prost::alloc::vec::Vec<u8>,
    #[prost(string, tag = "3")]
    pub avatar: ::prost::alloc::string::String,
    #[prost(uint32, tag = "4")]
    pub member_count: u32,
    #[prost(enumeration = "access_control::AccessRequired", tag = "5")]
    pub add_from_invite_link: i32,
    #[prost(uint32, tag = "6")]
    pub revision: u32,
    #[prost(bool, tag = "7")]
    pub pending_admin_approval: bool,
    #[prost(bytes = "vec", tag = "8")]
    pub description: ::prost::alloc::vec::Vec<u8>,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GroupExternalCredential {
    #[prost(string, tag = "1")]
    pub token: ::prost::alloc::string::String,
}
